Subject: Re: [PATCH 4/4] gnu: Add waydroid.

From: phodina <[email-masked]>
Date: Mon, 15 Nov 2021 22:30:12 +0000

Hi Liliana,

On Monday, November 15th, 2021 at 9:03 PM, Liliana Marie Prikler <[email-masked]> wrote:

> Hi,
>
> Am Mittwoch, den 10.11.2021, 01:39 +0000 schrieb phodina:
>
> > [...]
> >
> > -   (description "Waydroid uses Linux namespaces @code{(user, pid,
> >
> >     uts, net,
> >
> >     +mount, ipc)} to run a full Android system in a container and provide
> >
> >     Android
> >
> >     +applications. The Android inside the container has direct access to
> >
> >     needed
> >
> >     +underlying hardware. The Android runtime environment ships with a
> >
> >     minimal
> >
> >     +customized Android system image based on LineageOS. The used image
> >
> >     is
> >
> >     +currently based on Android 10.")
>
> How exactly/when is this RTE built? Is it just included as a blob?

Nope, it's downloaded as part of the =waydroid init= command.

You can see the RTE here:
$ ls /var/lib/waydroid/images/
system.img  vendor.img

On waydroid website [1] they provide instructions on how to create this runtime environment - basically "+-" Android rootfs.

I cameacross a channel [2] with Android support but haven't had the chance to test it yet. Then again I'm not sure if that's the right way as there are phones that run close to vanilla Linux [3]. Though this technological solution enables Android apps to run on those phones.

But it also has drawback as it requires custom kernel.

Though these patches require support in the kernel [3] and LXD service running [4] at least.

Currently I'm able to run the waydroid container and get shell over adb.

However, for some unknown reason I can't launch the UI.

That might be due to the fact I run Sway VM. I'll test this with GDM as this is recommended in the issues on github and report back.

Petr

[1]: https://docs.waydro.id/development/compile-waydroid-lineage-os-based-images
[2]: https://framagit.org/tyreunom/guix-android
[3]: https://postmarketos.org/
[4]: https://issues.guix.gnu.org/51771
[5]: https://issues.guix.gnu.org/50133